# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#	Bonbon's fun classes V 2.0 python					  #
#	Requires:									  #
#											  #
#		Eventscripts 2.0							  #  
#											  #
#	add the line es_load bclasses to your autoexec.cfg		  #
#											  #
#	Thank you to:								  #
#			Mattie who made the Quad mod (for glow)		  #
#			SD who made the jump multiplier and pickle thread  #
#			And the makers of the models included		  #
#											  #
#											  #
#											  #
#	If you have any questions e-mail me at:				  #
#	drunkenmousehide@hotmail.com					  #
#	or use the PMS on the eventscripts formums			  #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
import es
import playerlib
import popuplib

player_classes = {}
zombie_model = ['crispy.dx80.vtx', 'crispy.dx90.vtx', 'crispy.mdl', 'crispy.phy', 'crispy.sw.vtx', 'crispy.mdl']
zombie_material = ['charple1_sheet.vmt', 'charple2_sheet.vmt', 'crispy.vtf', 'crispy_normal.vtf']
zombie_model_dir = 'models/player/zombie/crispy/'
zombie_material_dir = 'materials/models/player/zombie/crispy/'
ghost_model = ['ghost.dx80.vtx', 'ghost.dx90.vtx', 'ghost.mdl', 'ghost.phy', 'ghost.sw.vxt', 'ghost.vvd']
ghost_material = ['ghost.vmt', 'ghost.vtf', 'ghost_spec.vtf']
ghost_model_dir = 'models/player/zombie/ghost/'
ghost_material_dir = 'materials/models/player/zombie/ghost/'
homer_model = ['sheiks_homer.dx80.vtx', 'sheiks_homer.dx90.vtx', 'sheiks_homer.mdl', 'sheiks_homer.phy', 'sheiks_homer.sw.vtx', 'sheiks_homer.vvd', 'sheiks_homer.xbox.vtx']
homer_material = ['eye01.vmt', 'homer.vmt', 'homer_e.vmt', 'mouththree.vmt', 'mouthtwo.vmt', 'eye01.vtf', 'homer.vtf', 'homer_slow.vtf', 'mouththree.vtf', 'mouthtwo.vtf']
homer_model_dir = 'models/player/slow/homer_v2/'
homer_material_dir = 'materials/models/player/slow/homer_v2/'
cat_model = ['kitty_cat.dx80.vtx', 'kitty_cat.dx90.vtx', 'kitty_cat.mdl', 'kitty_cat.phy', 'kitty_cat.sw.vtx', 'kitty_cat.vvd', 'kitty_cat.xbox.vtx']
cat_material = ['kitty_body_01.vmt', 'kitty_body_01.vtf', 'kitty_body_01_normal.vtf', 'kitty_eyes_01.vmt', 'kitty_eyes_01.vtf', 'kitty_hairstyle_01_normal.vtf', 'kitty_neko_mimi_01.vmt', 'kitty_neko_mimi_01.vtf', 'kitty_neko_mimi_01_normal.vtf', 'kitty_neko_mimi_02.vmt']
cat_material2 = ['kitty_hairstyle_01.vmt', 'kitty_hairstyle_slow.vtf']
cat_model_dir = 'models/player/slow/kitty/'
cat_material2_dir = 'materials/models/player/slow/kitty_cat/'
cat_material_dir = 'materials/models/player/slow/kitty/'
bclasses = None
jump_multiplier = 1.5

def load():
	zombie_model_dl()
	zombie_material_dl()
	ghost_model_dl()
	ghost_material_dl()
	cat_model_dl()
	cat_material_dl()
	cat_material2_dl
	homer_model_dl()
	homer_material_dl()
	bclasses = popuplib.easymenu('example_menu', None, classes_choice)
	bclasses.settitle("|-Bonbon's Classes-|")
	classes = ('Zombie', 'Ghost', 'Homer', 'Kitty Kat')
	for taco in classes:
		bclasses.addoption (taco, taco)

def player_connect(event_var):
	global player_classes
	userid = event_var['userid']
	player_classes[userid] = 1

def player_disconnect(event_var):
	userid = event_var['userid']
	if player_classes.has_key(userid): 
		del player_classes[userid]

def player_spawn(event_var):
	player = playerlib.getPlayer(event_var['userid'])
	userid = str(event_var['userid'])
	if player_classes.has_key(userid):
		if player_classes[userid] == 1: # Zombie
			player.set('speed', '0.7')
			player.set('health', '250')
			es.tell(event_var['userid'], '#multi', '#greenYou are now a #lightgreenZombie, #greenYou are slow, but you do have extra health!')
			player.set('model', 'player/zombie/crispy/crispy')
		elif player_classes[userid] == 2: # Ghost
			es.tell(event_var['userid'], '#multi', 'You are now a #lightgreenghost,#green You have invisibility, speed and low gravity. Be careful though, You do glow!') 
			es.server.queuecmd('es_xgive %s point_spotlight'%event_var['userid']) 
			es.server.queuecmd('es_xfire %s point_spotlight addoutput "angles -90 0 0"'%event_var['userid']) 
			es.server.queuecmd('es_xfire %s point_spotlight setparent !activator'%event_var['userid']) 
			es.server.queuecmd('es_xfire %s point_spotlight addoutput "spotlightlength 400"'%event_var['userid']) 
			es.server.queuecmd('es_xfire %s point_spotlight addoutput "spotlightwidth 400"'%event_var['userid']) 
			es.server.queuecmd('es_xfire %s point_spotlight addoutput "rendercolor 100 100 100"'%event_var['userid']) 
			es.server.queuecmd('es_xfire %s point_spotlight addoutput "angles -90 0 0"'%event_var['userid']) 
			es.server.queuecmd('es_xfire %s point_spotlight lighton'%event_var['userid'])
			player.set('speed', '1.4')
			player.set('model', 'player/zombie/ghost/ghost)')
		elif player_classes[userid] == 3: # Homer
			es.tell(event_var['userid'], '#multi', '#greenYou are now #lightgreenHomer Simpson,#green You are slow, but your fat protects you. But certain events make you drunk.')
			player.set('model', 'player/slow/homer_v2/sheiks_homer')
			player.set('speed', '0.7')
			player.set('health', '300')
		elif player_classes[userid] == 4: # Kitty
			es.tell(event_var['userid'], '#multi', '#greenYou are now a #lightgreenKitty Kat, #greenYou have special jumping powers, can go fast and can stun other people. But you have low health.')
			player.set('model', 'player/slow/kitty/kitty_cat')
			player.set('speed', '1.2') 
			player.set('health', '75')

def player_say(event_var):
	userid = event_var['userid']
	if player_classes.has_key(userid): 
		if event_var['text'] == '!zombie':
			player_classes[userid] = 1 # Zombie
		elif event_var['text'] == '!ghost':
			player_classes[userid] = 2 # Ghost
		elif event_var['text'] == '!homer':
			player_classes[userid] = 3 # Homer
		elif event_var['text'] == '!kitty':
			player_classes[userid] = 4 # Kitty
		elif event_var['text'] == '!bclass':
			popuplib.send('bclasses', event_var['userid'])
		
def player_jump(event_var):
	userid = event_var['userid']
	temp_multiplier = jump_multiplier - 1 
	if player_classes.has_key(userid): 
		if player_classes[userid] == 2:
			es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * temp_multiplier for x in range(3)]))
		elif player_classes[userid] == 4:
			es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * temp_multiplier for x in range(3)]))
		elif player_classes[userid] == 3:
			es.server.queuecmd('est_drunk %s 1'%event_var['userid'])

def classes_choice(userid, choice, popupname):
	userid = event_var['userid']
	if player_classes.has_key(userid): 
		if choice == 'Zombie':
			player_classes[userid] = 1 # Zombie
		elif choice == 'Ghost':
			player_classes[userid] = 2 # Ghost
		elif choice == 'Homer':
			player_classes[userid] = 3 # Homer
		elif choice == 'Kitty Kat':
			player_classes[userid] = 4 # Kitty

def player_hurt(event_var):
	attacker = event_var['attacker']
	userid = int(event_var['userid'])
	player = playerlib.getplayer(event_var['userid'])
	if player_classes.has_key(userid):
		if player_classes[attacker] == 4:
			player.set('freeze', '1')
			es.delayed(0.1, 'playerset freeze %s 0'%event_var['userid'])
		elif player_classes[userid] == 3:
			es.server.queuecmd('est_drunk %s 0.1'%event_var['userid'])

def bomb_beginplant(event_var):
	userid = event_var['userid']
	if player_classes.has_key(userid):
		if player_classes[userid] == 3:
			es.server.queuecmd('est_drunk %s 2'%event_var['userid'])
			es.tell(event_var['userid'], '#multi', '#greenYour Team is awarding your for starting to plant the bomb by giving you more beer!')

def bomb_begindefuse(event_var):
	userid = event_var['userid']
	if player_classes.has_key(userid):
		if player_classes[userid] == 3:
			es.server.queuecmd('est_drunk %s 2'%event_var['userid'])
			es.tell(event_var['userid'], '#multi', '#greenYour Team is awarding you for starting to defuse the bomb by giving you more beer!')

def zombie_model_dl():
	for a in zombie_model:
		es.stringtable('downloadables', zombie_model_dir + a)
def zombie_material_dl():
	for b in zombie_material:
		es.stringtable('downloadables', zombie_material_dir + b)

def ghost_model_dl():
	for c in ghost_model:
		es.stringtable('downloadables', ghost_model_dir + c)

def ghost_material_dl():
	for d in ghost_material:
		es.stringtable('downloadables', ghost_material_dir + d)

def homer_model_dl():
	for e in homer_model:
		es.stringtable('downloadables', homer_model_dir + e)

def homer_material_dl():
	for f in homer_material:
		es.stringtable('downloadables', homer_material_dir + f)

def cat_model_dl():
	for g in cat_model:
		es.stringtable('downloadables', cat_model_dir + g)

def cat_material_dl():
	for h in cat_material:
		es.stringtable('downloadables', cat_material_dir + h)

def cat_material2_dl():
	for h in pink_material2:
		es.stringtable('downloadables', cat_material2_dir + h)
